/* Creation of destination table and insertion of the data*/
CREATE TABLE  BST_TVL_DESTINATION_TB
(
	DESTINATIONNAME VARCHAR(30) PRIMARY KEY,
	DISTANCE 	INTEGER
)

INSERT INTO BST_TVL_DESTINATION_TB VALUES('SRISILAM',240)
INSERT INTO BST_TVL_DESTINATION_TB VALUES('NAGARJUNASAGAR',180)
INSERT INTO BST_TVL_DESTINATION_TB VALUES('TIRUPATI',720)
SELECT * FROM BST_TVL_DESTINATION_TB




/* Creation of vehicleinfo table and insertion of the data*/
CREATE TABLE BST_TVL_VEHICLEINFO_TB
(
	VEHICLENAME VARCHAR(20)PRIMARY KEY,
	VEHICLETYPE CHAR(10)NOT NULL,
	FUELTYPE CHAR(6)NOT NULL,
	SEATINGCAPACITY SMALLINT NOT NULL,
	RENTPERDAY SMALLMONEY NOT NULL,
	RENTPERKM SMALLMONEY NOT NULL
)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('SCORPIO','VAN','DIESEL',7,1800,20)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('TATASUMO','VAN','DIESEL',7,1700,18)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('TOYOTAQUALIS','VAN','DIESEL',7,2000,25)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('ESTEEM','CAR','PETROL',4,1750,12)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('HONDACITY','CAR','PETROL',4,2500,15)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('HYUNDAIACCENT','CAR','PETROL',4,2100,12)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('MARUTIOMNI','VAN','DIESEL',4,1600,10)
SELECT * FROM BST_TVL_VEHICLEINFO_TB




/* Creation of destination table and insertion of the data*/
CREATE TABLE BST_TVL_VEHICLE_TB
(
	VEHICLEID VARCHAR(9) PRIMARY KEY,
	VEHICLENAME VARCHAR(20),
	STATUS BIT 
	FOREIGN KEY (VEHICLENAME) REFERENCES BST_TVL_VEHICLEINFO_TB
)

INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP12J1234','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP12J6758','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP23J2738','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K5658','TATASUMO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP67K3472','TATASUMO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K5690','TOYOTAQUALIS',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K6784','TOYOTAQUALIS',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP1K6767','ESTEEM',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K7834','HONDACITY',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP5K5691','HYUNDAIACCENT',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP9K1580','MARUTIOMNI',0)
SELECT * FROM BST_TVL_VEHICLE_TB




/* Creation of Registration table*/
CREATE TABLE BST_TVL_REGISTRATION_TB
(
	REGISTRATIONID VARCHAR(30) PRIMARY KEY,
	COMPANYREPRESENTATIVENAME CHAR(20),
	COMPANYNAME CHAR(15),
	TELEPHONE CHAR(12),
	TOURISTDESTINATION VARCHAR(30),
	STARTDATE DATETIME,
	RETURNDATE DATETIME,
	NUMBEROFPEOPLE TINYINT,
	TOTALAMOUNT INT
)




/* Creation of Plans table*/
CREATE TABLE BST_TVL_PLANS_TB
(
	COMPANYREPRESENTATIVENAME CHAR(20),
	COMPANYNAME CHAR(15),
	TELEPHONE CHAR(12),
	DESTINATIONNAME VARCHAR(30),
	STARTDATE DATETIME,
	RETURNDATE DATETIME,
	VEHICLETYPE CHAR(10),
	NUMBEROFPEOPLE TINYINT,
	SELECTEDVEHICLE VARCHAR(70),
	TOTALAMOUNT INT
)

/* Creation of Bookedvehicles table*/

CREATE TABLE BST_TVL_BOOKED_VEHICLES_TB
(
	REGISTRATIONID VARCHAR(30),
	VEHICLEID VARCHAR(9),
	VEHICLENAME VARCHAR(20),
	PRIMARY KEY (REGISTRATIONID,VEHICLEID),
	FOREIGN KEY (VEHICLEID) REFERENCES BST_TVL_VEHICLE_TB,
	FOREIGN KEY (REGISTRATIONID) REFERENCES BST_TVL_REGISTRATION_TB
)




/*End of the tables creation////////////////////////////////////////////////////////////////////////////*/





/*some important Queries*/



SELECT * FROM BST_TVL_PLANS_TB
TRUNCATE TABLE BST_TVL_REGISTRATION_TB


SELECT VEHICLEID,VEHICLENAME FROM BST_TVL_VEHICLE_TB,BST_TVL_PLANS_TB WHERE BST_TVL_PLANS_TB.SELECTEDVEHICLE = BST_TVL_VEHICLE_TB.VEHICLENAME AND STATUS = 0
SELECT BST_TVL_VEHICLE_TB.VEHICLENAME FROM BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB ON BST_TVL_VEHICLE_TB.VEHICLENAME=BST_TVL_VEHICLEINFO_TB.VEHICLENAME AND BST_TVL_VEHICLEINFO_TB.VEHICLETYPE='VAN';

SELECT VEHICLEID,STARTDATE,RETURNDATE FROM BST_TVL_REGISTRATION_TB

SELECT R.VEHICLEID
FROM BST_TVL_REGISTRATION_TB AS R
WHERE R.STARTDATE<'23-11-06' AND


SELECT BST_TVL_VEHICLE_TB.VEHICLENAME,BST_TVL_VEHICLE_TB.VEHICLEID 
FROM BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB 
ON BST_TVL_VEHICLE_TB.VEHICLENAME=BST_TVL_VEHICLEINFO_TB.VEHICLENAME AND BST_TVL_VEHICLEINFO_TB.VEHICLETYPE='VAN'
WHERE BST_TVL_VEHICLE_TB.VEHICLEID NOT IN (
SELECT B.VEHICLEID
FROM BST_TVL_BOOKED_VEHICLES_TB AS B
INNER JOIN BST_TVL_REGISTRATION_TB AS R
ON B.REGISTRATIONID = R.REGISTRATIONID 
WHERE ('24-11-06'  BETWEEN R.STARTDATE AND R.RETURNDATE) AND ('25-11-06'  BETWEEN R.STARTDATE AND R.RETURNDATE)
)




SELECT BST_TVL_VEHICLE_TB.VEHICLENAME,BST_TVL_VEHICLE_TB.VEHICLEID 
FROM BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB 
ON BST_TVL_VEHICLE_TB.VEHICLENAME=BST_TVL_VEHICLEINFO_TB.VEHICLENAME AND BST_TVL_VEHICLEINFO_TB.VEHICLETYPE='VAN'
WHERE BST_TVL_VEHICLE_TB.VEHICLEID NOT IN (
SELECT B.VEHICLEID
FROM BST_TVL_BOOKED_VEHICLES_TB AS B
INNER JOIN BST_TVL_REGISTRATION_TB AS R
ON B.REGISTRATIONID = R.REGISTRATIONID 
WHERE ('30-11-06' BETWEEN R.STARTDATE AND R.RETURNDATE) AND ('02-11-06' BETWEEN R.STARTDATE AND R.RETURNDATE)
)

select BST_TVL_VEHICLE_TB.VehicleName,BST_TVL_VEHICLE_TB.VehicleId 
from BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB 
on BST_TVL_VEHICLE_TB.VehicleName=BST_TVL_VEHICLEINFO_TB.VehicleName and BST_TVL_VEHICLEINFO_TB.VehicleType='Car'


select BST_TVL_VEHICLE_TB.VEHICLENAME,BST_TVL_VEHICLE_TB.VEHICLEID
from BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB on BST_TVL_VEHICLE_TB.VEHICLENAME=BST_TVL_VEHICLEINFO_TB.VEHICLENAME and BST_TVL_VEHICLEINFO_TB.VEHICLETYPE='VAN' where BST_TVL_VEHICLE_TB.VEHICLEID not in (Select b.VEHICLEID from BST_TVL_BOOKED_VEHICLES_TB as b inner join BST_TVL_REGISTRATION_TB as r on b.REGISTRATIONID = r.REGISTRATIONID where ('24-11-06' between r.STARTDATE and r.RETURNDATE) and ('25-11-06' between r.STARTDATE and r.RETURNDATE))






/*some important operations*/

UPDATE BST_TVL_VEHICLE_TB SET STATUS = 0

TRUNCATE TABLE BST_TVL_VEHICLE_TB
TRUNCATE TABLE BST_TVL_PLANS_TB
TRUNCATE TABLE BST_TVL_REGISTRATION_TB
TRUNCATE TABLE BST_TVL_BOOKED_VEHICLES_TB


SELECT * FROM BST_TVL_VEHICLE_TB
SELECT * FROM BST_TVL_VEHICLEINFO_TB
SELECT * FROM BST_TVL_PLANS_TB
SELECT * FROM BST_TVL_REGISTRATION_TB
SELECT * FROM BST_TVL_BOOKED_VEHICLES_TB 

DROP TABLE BST_TVL_DESTINATION_TB
DROP TABLE BST_TVL_BOOKED_VEHICLES_TB
DROP TABLE BST_TVL_VEHICLE_TB
DROP TABLE BST_TVL_VEHICLEINFO_TB
DROP TABLE BST_TVL_REGISTRATION_TB
DROP TABLE BST_TVL_PLANS_TB




/* for debugging purpose only */

TRUNCATE TABLE BST_TVL_PLANS_TB
DROP TABLE BST_TVL_BOOKED_VEHICLES_TB
TRUNCATE TABLE BST_TVL_REGISTRATION_TB

CREATE TABLE BST_TVL_BOOKED_VEHICLES_TB
(
	REGISTRATIONID VARCHAR(30),
	VEHICLEID VARCHAR(9),
	VEHICLENAME VARCHAR(20),
	PRIMARY KEY (REGISTRATIONID,VEHICLEID),
	FOREIGN KEY (VEHICLEID) REFERENCES BST_TVL_VEHICLE_TB,
	FOREIGN KEY (REGISTRATIONID) REFERENCES BST_TVL_REGISTRATION_TB
)

SELECT * FROM BST_TVL_PLANS_TB
SELECT * FROM BST_TVL_REGISTRATION_TB
SELECT * FROM BST_TVL_BOOKED_VEHICLES_TB 


SELECT * FROM BST_TVL_DESTINATION_TB
SELECT * FROM BST_TVL_VEHICLE_TB
SELECT * FROM BST_TVL_VEHICLEINFO_TB
SELECT * FROM BST_TVL_PLANS_TB
SELECT * FROM BST_TVL_REGISTRATION_TB
SELECT * FROM BST_TVL_BOOKED_VEHICLES_TB 


SELECT BST_TVL_VEHICLE_TB.VEHICLENAME,BST_TVL_VEHICLE_TB.VEHICLEID 
FROM BST_TVL_VEHICLE_TB INNER JOIN BST_TVL_VEHICLEINFO_TB 
ON BST_TVL_VEHICLE_TB.VEHICLENAME=BST_TVL_VEHICLEINFO_TB.VEHICLENAME AND BST_TVL_VEHICLEINFO_TB.VEHICLETYPE='VAN'
WHERE BST_TVL_VEHICLE_TB.VEHICLEID NOT IN (
SELECT B.VEHICLEID
FROM BST_TVL_BOOKED_VEHICLES_TB AS B
INNER JOIN BST_TVL_REGISTRATION_TB AS R
ON B.REGISTRATIONID = R.REGISTRATIONID 
WHERE (('2006-11-26 12:00:00.000' BETWEEN R.STARTDATE AND R.RETURNDATE) or ('2006-11-28 12:00:00.000' BETWEEN R.STARTDATE AND R.RETURNDATE)) and ('24-11-06' < R.STARTDATE AND '30-11-06' > R.RETURNDATE)
)





/*for changing coding standards of a table*/


CREATE TABLE  BST_TVL_DESTINATION_TB
(
	PK_D_DESTINATION_NAME VARCHAR(30) PRIMARY KEY,
	D_DISTANCE 	INTEGER
)

INSERT INTO BST_TVL_DESTINATION_TB VALUES('SRISILAM',240)
INSERT INTO BST_TVL_DESTINATION_TB VALUES('NAGARJUNASAGAR',180)
INSERT INTO BST_TVL_DESTINATION_TB VALUES('TIRUPATI',720)
SELECT * FROM BST_TVL_DESTINATION_TB


CREATE TABLE BST_TVL_VEHICLEINFO_TB
(
	PK_VI_VEHICLE_NAME VARCHAR(20)PRIMARY KEY,
	VI_VEHICLE_TYPE CHAR(10)NOT NULL,
	VI_FUEL_TYPE CHAR(6)NOT NULL,
	VI_SEATING_CAPACITY SMALLINT NOT NULL,
	VI_RENT_PER_DAY SMALLMONEY NOT NULL,
	VI_RATE_PER_KM SMALLMONEY NOT NULL
)

INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('SCORPIO','VAN','DIESEL',7,1800,20)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('TATASUMO','VAN','DIESEL',7,1700,18)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('TOYOTAQUALIS','VAN','DIESEL',7,2000,25)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('ESTEEM','CAR','PETROL',4,1750,12)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('HONDACITY','CAR','PETROL',4,2500,15)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('HYUNDAIACCENT','CAR','PETROL',4,2100,12)
INSERT INTO BST_TVL_VEHICLEINFO_TB VALUES ('MARUTIOMNI','VAN','DIESEL',4,1600,10)
SELECT * FROM BST_TVL_VEHICLEINFO_TB


CREATE TABLE BST_TVL_VEHICLE_TB
(
	PK_V_VEHICLE_ID VARCHAR(9) PRIMARY KEY,
	FK_VEHICLE_VEHICLEINFO VARCHAR(20),
	V_STATUS BIT, 
	FOREIGN KEY (FK_VEHICLE_VEHICLEINFO) REFERENCES BST_TVL_VEHICLEINFO_TB(PK_VI_VEHICLE_NAME)
)


INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP12J1234','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP12J6758','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP23J2738','SCORPIO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K5658','TATASUMO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP67K3472','TATASUMO',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K5690','TOYOTAQUALIS',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K6784','TOYOTAQUALIS',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP1K6767','ESTEEM',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP45K7834','HONDACITY',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP5K5691','HYUNDAIACCENT',0)
INSERT INTO BST_TVL_VEHICLE_TB VALUES ('AP9K1580','MARUTIOMNI',0)
SELECT * FROM BST_TVL_VEHICLE_TB



CREATE TABLE BST_TVL_PLANS_TB
(
	P_COMPANY_REPRESENTATIVE_NAME CHAR(20),
	P_COMPANY_NAME CHAR(15),
	P_TELEPHONE CHAR(12),
	P_DESTINATION_NAME VARCHAR(30),
	P_START_DATE DATETIME,
	P_RETURN_DATE DATETIME,
	P_VEHICLE_TYPE CHAR(10),
	P_NUMBER_OF_PEOPLE TINYINT,
	P_SELECTED_VEHICLE VARCHAR(70),
	P_TOTAL_AMOUNT INT
)



CREATE TABLE BST_TVL_REGISTRATION_TB
(
	PK_R_REGISTRATION_ID VARCHAR(30) PRIMARY KEY,
	R_COMPANY_REPRESENTATIVE_NAME CHAR(20),
	R_COMPANY_NAME CHAR(15),
	R_TELEPHONE CHAR(12),
	R_TOURIST_DESTINATION VARCHAR(30),
	R_START_DATE DATETIME,
	R_RETURN_DATE DATETIME,
	R_NUMBER_OF_PEOPLE TINYINT,
	R_TOTAL_AMOUNT INT
)




CREATE TABLE BST_TVL_BOOKED_VEHICLES_TB
(       
        PK_BV_ID INT IDENTITY(1,1) PRIMARY KEY, 
	FK_BOKD_VEHICLE_REGISTRATION VARCHAR(30),
        FK_BOKD_VEHICLES_VEHICLE VARCHAR(9),
	BV_VEHICLE_NAME VARCHAR(20),
	FOREIGN KEY (FK_BOKD_VEHICLES_VEHICLE) REFERENCES BST_TVL_VEHICLE_TB(PK_V_VEHICLE_ID),
	FOREIGN KEY (FK_BOKD_VEHICLE_REGISTRATION) REFERENCES BST_TVL_REGISTRATION_TB(PK_R_REGISTRATION_ID)

)

DROP TABLE BST_TVL_BOOKED_VEHICLES_TB